import 'package:flutter/material.dart';
import '../controller/slider_controller.dart';
import 'package:provider_mvc/controller.dart';
import 'package:provider_mvc/view.dart';

class SliderView extends View<SliderController> {
  final Color _color;

  SliderView(this._color);

  @override
  Widget builder(
      BuildContext context, SliderController controller, Widget widget) {
    return Slider(
      activeColor: _color,
      value: controller.value.toDouble(),
      min: 0,
      max: 255,
      divisions: 256,
      label: '${controller.value}',
      onChanged: (value) {
        controller.value = value.toInt();
        Controller.of()?.single?.update();
      },
    );
  }

  @override
  SliderController create(BuildContext context) =>
      Controller.put<SliderController>(SliderController(_tag));

  String get _tag {
    String tag;

    if (_color == Colors.red) tag = 'RED';
    if (_color == Colors.green) tag = 'GREEN';
    if (_color == Colors.blue) tag = 'BLUE';

    return tag;
  }

  SliderController get controller =>
      Controller.find<SliderController>(_tag)?.single;
}
